<?php 
include("../glbinc.inc");

include($inc_path."fpdf/chinese.php");


//==========pdf class


class PDF_MySQL_Table extends PDF_Chinese
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;
var $db = null;//adodb
function setdb(&$conn)
{
	    if ($conn){
               $this->db = $conn;
          /*選擇存取的table files*/
        } else {
           if (!$conn) {
            die('連線尚未設定!');
           } else {
            die ('找不到資料庫!');
           }
	    }
}
function Header()
{
    //Print the table header if necessary
    if($this->ProcessingTable)
        $this->TableHeader();
}

function TableHeader()
{
    $this->SetFont('uni','B',12);
    $this->SetX($this->TableX);
    $fill=!empty($this->HeaderColor);
    if($fill)
        $this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
    foreach($this->aCols as $col)
        $this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
    $this->Ln();
}

function Row($data)
{
    $this->SetX($this->TableX);
    $ci=$this->ColorIndex;
    $fill=!empty($this->RowColors[$ci]);
    if($fill)
        $this->SetFillColor($this->RowColors[$ci][0],$this->RowColors[$ci][1],$this->RowColors[$ci][2]);
    foreach($this->aCols as $col)
    {
	if(!is_array($col['r'])){
        $this->Cell($col['w'],5,$data[$col['f']],1,0,$col['a'],$fill);
	}else{
	  $refn=$col['r'];
	  //global $$refn;
	  //$refname=$$refn;
        $this->Cell($col['w'],5,$refn[$data[$col['f']]],1,0,$col['a'],$fill);		
	}
    }
    $this->Ln();
    $this->ColorIndex=1-$ci;
}

function CalcWidths($width,$align)
{
    //Compute the widths of the columns
    $TableWidth=0;
    foreach($this->aCols as $i=>$col)
    {
        $w=$col['w'];
        if($w==-1)
            $w=$width/count($this->aCols);
        elseif(substr($w,-1)=='%')
            $w=$w/100*$width;
        $this->aCols[$i]['w']=$w;
        $TableWidth+=$w;
    }
    //Compute the abscissa of the table
    if($align=='C')
        $this->TableX=max(($this->w-$TableWidth)/2,0);
    elseif($align=='R')
        $this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
    else
        $this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align='L',$ref='')
{
    //Add a column to the table
    if($field==-1)
        $field=count($this->aCols);
    $this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align,'r'=>$ref);
}

function Table($query,$prop=array())
{
	global $conn;
	if(!empty($conn)){$this->setdb($conn);}
    //Issue query
    $res=$this->db->Execute($query) or die('Error: '.mysql_error()."<BR>Query: $query");
    //Add all columns if none was specified
    if(count($this->aCols)==0)
    {
        //$nb=mysql_num_fields($res);
		$nb=$res->FieldCount();
        for($i=0;$i<$nb;$i++)
            $this->AddCol();
    }
    //Retrieve column names when not specified
    foreach($this->aCols as $i=>$col)
    {
        if($col['c']=='')
        {
            if(is_string($col['f'])){
                $this->aCols[$i]['c']=ucfirst($col['f']);
            }else{
                //$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
                  $fj  = $res->FetchField($col['f']);
			    $this->aCols[$i]['c']=ucfirst($fj->name);
			}
        }
    }
    //Handle properties
    if(!isset($prop['width']))
        $prop['width']=0;
    if($prop['width']==0)
        $prop['width']=$this->w-$this->lMargin-$this->rMargin;
    if(!isset($prop['align']))
        $prop['align']='C';
    if(!isset($prop['padding']))
        $prop['padding']=$this->cMargin;
    $cMargin=$this->cMargin;
    $this->cMargin=$prop['padding'];
    if(!isset($prop['HeaderColor']))
        $prop['HeaderColor']=array();
    $this->HeaderColor=$prop['HeaderColor'];
    if(!isset($prop['color1']))
        $prop['color1']=array();
    if(!isset($prop['color2']))
        $prop['color2']=array();
    $this->RowColors=array($prop['color1'],$prop['color2']);
    //Compute column widths
    $this->CalcWidths($prop['width'],$prop['align']);
    //Print header
    $this->TableHeader();
    //Print rows
    $this->SetFont('uni','',11);
    $this->ColorIndex=0;
    $this->ProcessingTable=true;
	//while($row=mysql_fetch_array($res))
	while($row=$res->FetchRow())
            $this->Row($row);
    $this->ProcessingTable=false;
    $this->cMargin=$cMargin;
    $this->aCols=array();
}
}
class PDF extends PDF_MySQL_Table
{
var $title,$pgname,$cond;
function Header()
{
    //Title
    $this->SetTextColor(0,0,0);
	$this->setX($this->tableX);
    $this->SetFont('uni','B',14);
    $this->Cell(0,6,$this->title,0,1,'C');
    $this->SetFont('uni','B',11);
    //$this->SetFont('Arial','',18);
	$this->setX($this->lMargin);
	$ptime='印表時間: '.date("Y/m/d H:i");
	$this->Cell(10,6,$ptime,0,0,'L');
	$this->setX($this->tableX);
    $this->Cell(0,6,$this->pgname,0,0,'C');
	$this->setX($this->rMargin-50);
	$this->Cell(0,6,'頁次: '.$this->PageNo().'/'.$this->page,0,0,'L');
//	$this->Cell(0,6,'頁次: '.$this->PageNo().'/'.$this->page,0,0,'L');
    $this->Ln();
	$this->Cell(10,6,$this->cond,0,0,'L');
    $this->Ln();
    //==========Column Header
    $this->SetFont('uni','',11);
	$this->Cell(12,6,'房號',1,0,'L');
	$this->Cell(50,6,'客戶姓名',1,0,'L');
	$this->Cell(35,6,'交易時間',1,0,'L');
	$this->Cell(20,6,'產品編號',1,0,'L');
	$this->Cell(35,6,'產品名稱',1,0,'L');
	$this->Cell(20,6,'數量',1,0,'L');
	$this->Cell(20,6,'定價',1,0,'L');
	$this->Cell(30,6,'交易金額',1,0,'C');
	//$this->Cell(20,6,'折價券編號',1,0,'C');
	$this->Cell(50,6,'備註說明',1,0,'C');
  $this->Ln();
    //Ensure table header is output
    parent::Header();
}
}

//====end class
  $querystr='';
  $sql="select * from salemaster where 1=1 order by p_code, account_time";
  //$querystr=getquerystr($trs,$sel_method);
  if (empty($s_pcode)) {$s_pcode='0';}
  if (empty($e_pcode)) {$e_pcode='z';}
  $querystr.=" p_code between '$s_pcode' and '$e_pcode' and p_code not in (select p_code from prodmaster where class_code in ('A','B','R','SR')) and p_code not like 'G%' ";

  //日期區間
  //if (empty($querystr)) {$querystr = "(1=1)";}
  if (empty($begdt)) { $begdt='0000-00-00';}
  if (empty($enddt)) { $enddt='9999-12-31';}
//  $querystr.= " ".$sel_method."  ( sysdtm between '$begdttm' and '$enddttm' )  ";
  $querystr.= " ".$sel_method." date_format(account_time,'%Y-%m-%d') between '$begdt' and '$enddt' ";
  $sql=ereg_replace ("1=1", $querystr, $sql);  
   /******************************************/
//    saymsg("soyalsql = $soyalsql");
//echo "$sql";
  $rs=&$conn->Execute($sql);
  if (!$rs) {
        print ($strMeta."<h3>(hfs_couponacc).</h3><br>".$conn->ErrorMsg());
        exit;
    }
  if ($rs->rowcount()==0) {
        print ($strMeta."<h3>查 無 資 料.</h3><br>");
        exit;
    }

//=======================
//====開啟pdf
//$xylen=array(110.0,155.0);//25.54*6=155
if (empty($p_size)) $p_size='a4';
$pdf=new PDF("L","mm",$p_size);
//$pdf->SetFontSize(14);
$pdf->AddBig5Font();
$pdf->Open();
$sqlstr="select * from admsetup";
$rsstr=&$conn->Execute($sqlstr);
if ($rsstr->Rowcount()==0) {
	$pdf->title='admsetup 無公司名稱';
} else {
        $pdf->title=$rsstr->fields("hname");
}	
$pdf->pgname='<<交易明細表-依產品編號>>';
$pdf->cond ='列印條件:';
$pdf->cond.=' 日期起迄['.$begdt.']~['.$enddt.']';
$pdf->cond.=" 產品編號:[".$s_pcode."]~[".$e_pcode."]";

	$pdf->AddPage();
	$pdf->AliasNbPages();
  $pdf->SetFont('uni','',11);
	$lwidth=$pdf->w - $pdf->lMargin;
    $tot_s_sum=0;
    $tot_s_qty=0;
	while (!$rs->EOF) {
		$account_time=$rs->fields('account_time');
		$room_no=$rs->fields('room_no');
		$v_name=$rs->fields('v_name');
    $v_name=(mb_strlen($v_name) > 15)?utf8_substr($v_name,0,20,'UTF-8'):$v_name." \n"."　";//substr($ci_no,8);

		$p_code=$rs->fields('p_code');
		$sqlx="select p_name_c from prodmaster where p_code='$p_code'";
		$rsx=$conn->Execute($sqlx);
		$p_name_c='';
		if (!$rs->EOF) {
		  $p_name_c=$rsx->fields('p_name_c');
    }
    $rsx->Close();
		$s_qty=$rs->fields('s_qty');
		$s_price=$rs->fields('s_price');
		$s_sum=$rs->fields('s_sum');
		$coup_no=$rs->fields('coup_no');
		$s_remark=$rs->fields('s_remark');
        $tot_s_sum+=$s_sum;
        $tot_s_qty+=$s_qty;
    
		$pdf->Cell(12,6,"$room_no",1,0,'L');
		$pdf->Cell(50,6,"$v_name",1,0,'L');
		$pdf->Cell(35,6,"$account_time",1,0,'L');
		$pdf->Cell(20,6,"$p_code",1,0,'L');
		$pdf->Cell(35,6,"$p_name_c",1,0,'L');
		$pdf->Cell(20,6,"$s_qty",1,0,'R');
		$pdf->Cell(20,6,"$s_price",1,0,'R');
		$pdf->Cell(30,6,"$s_sum",1,0,'R');
		//$pdf->Cell(20,6,"$coup_no",1,0,'L');
		$pdf->Cell(50,6,"$s_remark",1,0,'L');
		$pdf->Ln();
		$rs->MoveNext();
		$irc++;
	}
	$rs->Close();
//	$pdf->SetFont('uni','B',11);
//	$pdf->Cell(0,6,">>>共 $rows 筆<<<",0,1,'C');
    $pdf->Cell(117,6,"合計",1,0,'C');
    $pdf->Cell(35,6,"數量",1,0,'C');
    $pdf->Cell(20,6,"$tot_s_qty",1,0,'R');
    $pdf->Cell(20,6,"",1,0,'C');
    $pdf->Cell(30,6,"金額",1,0,'C');
    $pdf->Cell(50,6,"$tot_s_sum",1,0,'R');
	$pdf->Output();

function utf8_substr($StrInput,$strStart,$strLen)
{
//對字串做URL Eecode
$StrInput = mb_substr($StrInput,$strStart,mb_strlen($StrInput));
$iString = urlencode($StrInput);
$lstrResult="";
$istrLen = 0;
$k = 0;
do{
$lstrChar = substr($iString, $k, 1);
if($lstrChar == "%"){
$ThisChr = hexdec(substr($iString, $k+1, 2));
if($ThisChr >= 128){
if($istrLen+3 < $strLen){
$lstrResult .= urldecode(substr($iString, $k, 9));
$k = $k + 9;
$istrLen+=3;
}else{
$k = $k + 9;
$istrLen+=3;
}
}else{
$lstrResult .= urldecode(substr($iString, $k, 3));
$k = $k + 3;
$istrLen+=2;
}
}else{
$lstrResult .= urldecode(substr($iString, $k, 1));
$k = $k + 1;
$istrLen++;
}
}while ($k < strlen($iString) && $istrLen < $strLen); 
return $lstrResult;
}
  
?>
