/*****************************************************************************/
/******Program Name: soyal.c                                   ***************/
/******Author: David Wu                                        ***************/
/******Written Date: 2008-10-15                                ***************/
/******Libraries: xampp develope 1.6.7                         ***************/
/******Usage:                                                  ***************/ 
/***1. ln libmysqlclient.so.15 libmysqlclient.so               ***************/
/***2. ln -s /opt/lampp/var/mysql/mysql.sock /var/lib/mysql/mysql.sock    ****/
/***3.cc -I/home/david/lampp/lib/mysql $1.c -lmysqlclient -lnsl -lm -lz -o $1*/
/***4.Execute: soyal >> /opt/lampp/logs/soyal_log 2>&1         ***************/
/*****************************************************************************/
#include </home/david/lampp/include/mysql/mysql.h>
//#include </opt/lampp/include/mysql/mysql.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

main() {
   MYSQL *conn, *soyalconn;
   MYSQL_RES *res, *soyalres;
   MYSQL_ROW row, soyalrow;
 
   time_t rawtime;
   struct tm * timeinfo;
   char timebuf[50];
   time (&rawtime);
   timeinfo = localtime(&rawtime);
   strftime(timebuf,50,"%Y-%m-%d %a %H:%M:%S",timeinfo);

//   char *server = "mysql-server.ucl.ac.uk";
   char *server = "localhost";
   char *user = "chienhen";
   char *password = "1264";
   char *database = "kindness1";

   char *soyalserver = "192.168.0.207";
   char *soyaluser = "wang";
   char *soyalpassword = "wang111";
   char *soyaldatabase = "soyaldb";
   
   char execsql[512],roomnum[6],di00[2],di01[2],di02[2],di03[2],do00[2];
   char co_alert[2],emg_alert[2];

   conn = mysql_init(NULL);
   soyalconn = mysql_init(NULL);
   
   /* Connect to database */
   if (!mysql_real_connect(conn, server,
         user, password, database, 0, NULL, 0)) {
      fprintf(stderr, "%s\t%s\n",asctime(timeinfo), mysql_error(conn));
      exit(0);
   }
   if (!mysql_real_connect(soyalconn, soyalserver,
         soyaluser, soyalpassword, soyaldatabase, 0, NULL, 0)) {
      fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(soyalconn));
// Lksu soyaldb
      if (mysql_query(conn, "update admsetup set connect_status='Y'")) {
         fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(conn));
         exit(0);
      }
      if (mysql_query(conn, "update roomcon set con_abort='Y'")) {
         fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(conn));
         exit(0);
      }
     
      exit(0);
   }

   /* update localhost SQL query */
   if (mysql_query(conn, "update admsetup set connect_status='N'")) {
      fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(conn));
      exit(0);
   }
   if (mysql_query(conn, "update roomcon set con_abort='N'")) {
      fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(conn));
      exit(0);
   }
   /* select soyaldb SQL query */
   if (mysql_query(soyalconn, "select * from roomio order by roomnum")) {
      fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(soyalconn));
      exit(0);
   }

   soyalres = mysql_use_result(soyalconn);
   
   /* output fields 1 and 2 of each row */
   while ((soyalrow = mysql_fetch_row(soyalres)) != NULL) {
      sprintf(roomnum,"%s",soyalrow[0]);
      sprintf(di00,"%s",soyalrow[1]);
      sprintf(di01,"%s",soyalrow[2]);
      sprintf(di02,"%s",soyalrow[3]);
      sprintf(di03,"%s",soyalrow[4]);
      sprintf(do00,"%s",soyalrow[5]);
      if (strcmp(di02,"1")==0) { strcpy(co_alert,"Y"); } else { strcpy(co_alert,"N");}
      if (strcmp(di01,"1")==0) { strcpy(emg_alert,"Y"); } else { strcpy(emg_alert,"N");}
      //printf("room_no=%s di0=%s\n", room_no, di0);
      sprintf(execsql,"update roomcon set co_alert='%s',emg_alert='%s' where room_no='%s'",co_alert,emg_alert,roomnum);
      if (mysql_query(conn, execsql)) {
         fprintf(stderr, "%s\t%s\n",timebuf, mysql_error(conn));
         exit(0);
      }
      //printf("room_no=%s di0=%s\n", soyalrow[0], soyalrow[1]);
   }

   /* Release memory used to store results and close connection */
   mysql_free_result(soyalres);
   mysql_close(soyalconn);
   //mysql_free_result(res);
   mysql_close(conn);
}
